import numpy

NPZ = "power_consumption.npz"

def main():
    try:
        trace = numpy.load(NPZ)
    except FileNotFoundError:
        print("%s is missing." % NPZ)
        return 1

    data = trace['arr_0'][700000:1489300]
    
    pattern_x = 0
    peak_count = 0
    peak_count_array = []
    for y in data:
        if (y < -0.05): # peak
            if (pattern_x < 500):
                # same pattern
                peak_count += 1
            else:
                # next pattern
                peak_count_array.append(peak_count)
                peak_count = 1
                pattern_x = 0
        pattern_x += 1
    
    d = 0 # private exponent
    bit_sel = 0 
    for peak_count in peak_count_array:
        if peak_count > 26:
            # square + multiply
            d |= 1 << bit_sel
        bit_sel += 1
    print("%x" % d)
    return 0

if __name__ == "__main__":
    main()

# $ python3 1.py
# 23d87cdf97bb95abe6273c384190c765f552ab86f6de30a8db74435c95e6e3138f54af689812d8f9359cf0f4d453a0c11ec68ce470216c09e74c8947adaf23e902415d61ddf2c0ffe459cbb40f7de42bdb7cd14093100a570e8c29819765e2d8d276f86471b52ac29aa2ce2bb72cd45006279e82bec253ae9675fe45824f6001

