#!/usr/bin/python
# -*- coding: utf-8 -*

import sys
import binascii

btn = ""

def info(msg):
	print("[\033[34;1mi\033[0m] %s" % (msg))

def ok(msg):
	print("[\033[32;1m+\033[0m] %s" % (msg))

def warn(msg):
	print("[\033[33;1mw\033[0m] %s" % (msg))

def error(msg):
	print("[\033[31;1m!\033[0m] %s" % (msg))

def bloc0(x1, y1):
    # x1 != y1
    t1 = x1 & (not y1)
    t2 = y1 & (not x1)
    return t1 | t2

def bloc1(x1, x2, y1, y2):
    # x1 if x2 else y1
    t1 = x1 & x2
    t2 = y1 & (not x2)
    return t1 | t2

def bloc(x1, y1, z1, a1, b1):
    t1 = x1 | y1
    t2 = x1 & y1
    t3 = x1 ^ y1

    t4 = t3 ^ z1
    t5 = t3 & z1

    t6 = t5 | t2

    t7 = bloc1(t1, a1, t2, a1)
    t8 = bloc1(t4, a1, t3, a1)

    t9 = bloc1(t8, b1, t7, b1)
    return t6, t9

def secure_device(a,b,op):
        out = 0

        _b1 = btn[0] == '1'
        _b2 = btn[1] == '1'
        _b3 = btn[2] == '1'
        _b4 = btn[3] == '1'
        
        a0 = (a & 0b1) & 0b1
        a1 = (a & (0b1 << 1)) >> 1
        a2 = (a & (0b1 << 2)) >> 2
        a3 = (a & (0b1 << 3)) >> 3
        a4 = (a & (0b1 << 4)) >> 4
        a5 = (a & (0b1 << 5)) >> 5
        a6 = (a & (0b1 << 6)) >> 6
        a7 = (a & (0b1 << 7)) >> 7

        b0 = (b & 0b1)
        b1 = (b & (0b1 << 1)) >> 1
        b2 = (b & (0b1 << 2)) >> 2
        b3 = (b & (0b1 << 3)) >> 3
        b4 = (b & (0b1 << 4)) >> 4
        b5 = (b & (0b1 << 5)) >> 5
        b6 = (b & (0b1 << 6)) >> 6
        b7 = (b & (0b1 << 7)) >> 7

        op0 = (op & 0b1)
        op1 = (op & (0b1 << 1)) >> 1
        
        s1  = bloc1(a6, _b3, a7, _b3)
        s2  = bloc1(a5, _b3, a6, _b3)
        s3  = bloc1(a4, _b3, a5, _b3)
        s4  = bloc1(a3, _b3, a4, _b3)
        s5  = bloc1(a2, _b3, a3, _b3)
        s6  = bloc1(a1, _b3, a2, _b3)
        s7  = bloc1(a0, _b3, a1, _b3)
        s8  = bloc1(a7, _b3, a0, _b3)

        ss1 = bloc1(b6, _b4, b7, _b4) 
        ss2 = bloc1(b5, _b4, b6, _b4) 
        ss3 = bloc1(b4, _b4, b5, _b4) 
        ss4 = bloc1(b3, _b4, b4, _b4) 
        ss5 = bloc1(b2, _b4, b3, _b4) 
        ss6 = bloc1(b1, _b4, b2, _b4) 
        ss7 = bloc1(b0, _b4, b1, _b4) 
        ss8 = bloc1(b7, _b4, b0, _b4) 

        pp1 = bloc0(op0, _b1)
        pp2 = bloc0(op1, _b2)

        t, out0 = bloc(ss8, s8, 0, pp1, pp2)
        t, out1 = bloc(ss7, s7, t, pp1, pp2)
        t, out2 = bloc(ss6, s6, t, pp1, pp2)
        t, out3 = bloc(ss5, s5, t, pp1, pp2)
        t, out4 = bloc(ss4, s4, t, pp1, pp2)
        t, out5 = bloc(ss3, s3, t, pp1, pp2)
        t, out6 = bloc(ss2, s2, t, pp1, pp2)
        t, out7 = bloc(ss1, s1, t, pp1, pp2)

        out |= (out7 << 7)
        out |= (out6 << 6)
        out |= (out5 << 5)
        out |= (out4 << 4)
        out |= (out3 << 3)
        out |= (out2 << 2)
        out |= (out1 << 1)
        out |= (out0)
        
        return out

def step1():
	r = secure_device(0x35,0x27,3)
	r = secure_device(0x7e,r,3)
	r = secure_device(0x66,r,2)
	r = secure_device(0x8,r,1)
	r = secure_device(0x13,r,0)
	r = secure_device(0x1f,r,1)
	r = secure_device(0xa,r,2)
	r = secure_device(0xd3,r,0)
	r = secure_device(0xc6,r,3)
	return r

def step2():
	r= secure_device(0xde,0xab,0)
	r= secure_device(0x67,r,3)
	r= secure_device(0x2a,r,2)
	r= secure_device(0x6d,r,1)
	r= secure_device(0x4a,r,3)
	r= secure_device(0xe7,r,0)
	r= secure_device(0x1c,r,1)
	r= secure_device(0x35,r,0)
	r= secure_device(0xde,r,3)
	r= secure_device(0xf7,r,0)
	r= secure_device(0xda,r,2)
	return r

def step1():
	r = secure_device(0x35,0x27,3)
	r = secure_device(0x7e,r,3)
	r = secure_device(0x66,r,2)
	r = secure_device(0x8,r,1)
	r = secure_device(0x13,r,0)
	r = secure_device(0x1f,r,1)
	r = secure_device(0xa,r,2)
	r = secure_device(0xd3,r,0)
	r = secure_device(0xc6,r,3)
	return r

def step2():
	r= secure_device(0xde,0xab,0)
	r= secure_device(0x67,r,3)
	r= secure_device(0x2a,r,2)
	r= secure_device(0x6d,r,1)
	r= secure_device(0x4a,r,3)
	r= secure_device(0xe7,r,0)
	r= secure_device(0x1c,r,1)
	r= secure_device(0x35,r,0)
	r= secure_device(0xde,r,3)
	r= secure_device(0xf7,r,0)
	r= secure_device(0xda,r,2)
	return r

def step3():
	r = secure_device(0x14,0x23,3)
	r = secure_device(0x72,r,0)
	r = secure_device(0x48,r,3)
	r = secure_device(0x53,r,1)
	r = secure_device(0xa7,r,0)
	r = secure_device(0x5f,r,1)
	r = secure_device(0x3,r,3)
	r = secure_device(0xb7,r,3)
	r = secure_device(0x73,r,1)
	r = secure_device(0x37,r,3)
	r = secure_device(0xc5,r,2)
	r = secure_device(0xa4,r,1)
	r = secure_device(0x30,r,0)
	r = secure_device(0xdd,r,2)
	return r

def step4():
	r = secure_device(0xb0,0x42,2)
	r = secure_device(0xbc,r,2)
	r = secure_device(0xfc,r,2)
	r = secure_device(0x54,r,3)
	r = secure_device(0x30,r,2)
	r = secure_device(0x97,r,1)
	r = secure_device(0xe8,r,2)
	r = secure_device(0xd6,r,0)
	r = secure_device(0x26,r,0)
	r = secure_device(0xeb,r,0)
	r = secure_device(0x68,r,1)
	r = secure_device(0x26,r,0)
	r = secure_device(0x9,r,3)
	r = secure_device(0x2a,r,2)
	r = secure_device(0xa9,r,3)
	return r

def step5():
	r = secure_device(0xff,0x12,0)
	r = secure_device(0xfd,r,1)
	r = secure_device(0xe5,r,1)
	r = secure_device(0x26,r,3)
	r = secure_device(0x85,r,3)
	r = secure_device(0x63,r,1)
	r = secure_device(0x93,r,3)
	r = secure_device(0xba,r,2)
	r = secure_device(0x97,r,0)
	r = secure_device(0xab,r,1)
	r = secure_device(0x6e,r,3)
	r = secure_device(0xfd,r,0)
	r = secure_device(0x4c,r,3)
	r = secure_device(0x50,r,0)
	r = secure_device(0xa,r,2)
	r = secure_device(0xfc,r,3)
	r = secure_device(0xe3,r,2)
	r = secure_device(0xa6,r,3)
	r = secure_device(0x64,r,2)
	r = secure_device(0x8e,r,3)
	r = secure_device(0xc1,r,1)
	return r

def step6():
	r = secure_device(0x90,0x77,1)
	r = secure_device(0x8e,r,0)
	r = secure_device(0xbd,r,2)
	r = secure_device(0x39,r,2)
	r = secure_device(0x4c,r,2)
	r = secure_device(0xc5,r,2)
	r = secure_device(0xb6,r,3)
	r = secure_device(0x93,r,1)
	r = secure_device(0x9f,r,3)
	r = secure_device(0xd6,r,3)
	r = secure_device(0x6e,r,2)
	r = secure_device(0x39,r,3)
	r = secure_device(0x40,r,1)
	r = secure_device(0x14,r,2)
	r = secure_device(0xe6,r,3)
	return r

def step7():
	r = secure_device(0xf,0xab,3)
	r = secure_device(0xa2,r,1)
	r = secure_device(0x7c,r,0)
	r = secure_device(0x34,r,1)
	r = secure_device(0x14,r,1)
	r = secure_device(0xe7,r,0)
	r = secure_device(0xb9,r,0)
	r = secure_device(0xf1,r,2)
	r = secure_device(0xd5,r,1)
	r = secure_device(0x4e,r,2)
	r = secure_device(0xe,r,2)
	r = secure_device(0x6,r,0)
	r = secure_device(0x7d,r,2)
	r = secure_device(0x87,r,3)
	r = secure_device(0xbc,r,0)
	r = secure_device(0xd4,r,3)
	r = secure_device(0x8a,r,1)
	r = secure_device(0xe7,r,3)
	r = secure_device(0x9e,r,1)
	r = secure_device(0x58,r,0)
	r = secure_device(0x24,r,2)
	r = secure_device(0x44,r,3)
	r = secure_device(0xc9,r,1)
	r = secure_device(0xd4,r,1)
	r = secure_device(0x1d,r,3)
	r = secure_device(0xcd,r,0)
	r = secure_device(0xde,r,1)
	r = secure_device(0x54,r,0)
	r = secure_device(0x5e,r,2)
	r = secure_device(0x46,r,1)
	r = secure_device(0x21,r,0)
	r = secure_device(0xff,r,1)
	r = secure_device(0x51,r,0)
	r = secure_device(0x78,r,1)
	r = secure_device(0x2f,r,3)
	r = secure_device(0xed,r,2)
	r = secure_device(0x4b,r,3)
	r = secure_device(0x4d,r,2)
	return r

def step8():
	r = secure_device(0x88,0x74,0)
	r = secure_device(0x48,r,2)
	r = secure_device(0x11,r,2)
	r = secure_device(0x76,r,0)
	r = secure_device(0x2b,r,3)
	r = secure_device(0xf8,r,2)
	return r

def init():
	r = secure_device(0x46,0x92,0);
	r = secure_device(0xdf,r,2)
	r = secure_device(0x3e,r,0)
	r = secure_device(0x3a,r,3)
	r = secure_device(0x36,r,2)
	r = secure_device(0x8e,r,2)
	r = secure_device(0xc9,r,3)
	r = secure_device(0xe7,r,1)
	r = secure_device(0x29,r,2)
	r = secure_device(0xc2,r,2)
	r = secure_device(0x79,r,0)
	r = secure_device(0x2a,r,2)
	r = secure_device(0x4c,r,3)
	r = secure_device(0xde,r,0)
	r = secure_device(0x88,r,0)
	r = secure_device(0x8b,r,2)
	r = secure_device(0x97,r,3)
	r = secure_device(0x6a,r,2)
	r = secure_device(0x60,r,1)
	r = secure_device(0x0f,r,0)
	r = secure_device(0x5b,r,3)
	r = secure_device(0xd0,r,2)
	r = secure_device(0xa9,r,1)
	r = secure_device(0xe3,r,3)
	r = secure_device(0xd0,r,1)
	r = secure_device(0x27,r,0)
	r = secure_device(0x90,r,0)
	r = secure_device(0x3b,r,1)
	r = secure_device(0x66,r,2)
	r = secure_device(0xe2,r,0)
	r = secure_device(0x24,r,3)
	r = secure_device(0xee,r,1)
	r = secure_device(0xf2,r,3)
	return r


def main():
        global btn # 4-bit combination

        info("Dechiffrement du conteneur\n")

        info("Initialisation du secure element")

        info("Merci d'appuyer les 4 boutons du secure element puis appuyer sur entrée")

        btn = "1111"
        if init()!=0xa1:
                error("Mauvaise initialisation, vérifiez l'état du sécure élement")
                sys.exit(0)
        else:
                ok("Initialisation, check 1 OK")
	
        info("Merci de relâcher les 4 boutons du secure element puis appuyer sur entrée")
        btn = "0000" 
        if init()!=0xe0:
                error("Mauvaise initialisation, vérifiez l'état du sécure élement")
                sys.exit(0)
        else:
                ok("Initialisation, check 2 OK")

        btn_16 = ["0000", "0001", "OO10", "0011", "0100", "0101", "0110", "0111",
                  "1000", "1001", "1O10", "1011", "1100", "1101", "1110", "1111"]

        s1 = []
        for i1 in btn_16:
       	    btn = i1
       	    s1.append(step1())
        s2 = []
        for i1 in btn_16:
       	    btn = i1
       	    s2.append(step2())
        s3 = []
        for i1 in btn_16:
       	    btn = i1
       	    s3.append(step3())
        s4 = []
        for i1 in btn_16:
       	    btn = i1
       	    s4.append(step4())
        s5 = []
        for i1 in btn_16:
       	    btn = i1
       	    s5.append(step5())
        s6 = []
        for i1 in btn_16:
       	    btn = i1
       	    s6.append(step6())
        s7 = []
        for i1 in btn_16:
       	    btn = i1
       	    s7.append(step7())
        s8 = []
        for i1 in btn_16:
       	    btn = i1
       	    s8.append(step8())

        info("s1: %s" % sorted(s1)) 
        info("s2: %s" % sorted(s2)) 
        info("s3: %s" % sorted(s3)) 
        info("s4: %s" % sorted(s4)) 
        info("s5: %s" % sorted(s5)) 
        info("s6: %s" % sorted(s6)) 
        info("s7: %s" % sorted(s7)) 
        info("s8: %s" % sorted(s8)) 

if __name__ == '__main__':
        main()

# $ python3 1.py
# [i] Dechiffrement du conteneur
# 
# [i] Initialisation du secure element
# [i] Merci d'appuyer les 4 boutons du secure element puis appuyer sur entrée
# [+] Initialisation, check 1 OK
# [i] Merci de relâcher les 4 boutons du secure element puis appuyer sur entrée
# [+] Initialisation, check 2 OK
# [i] s1: [25, 57, 64, 71, 98, 114, 129, 137, 143, 144, 175, 191, 194, 199, 215, 223]
# [i] s2: [8, 16, 32, 41, 50, 82, 144, 164, 180, 181, 209, 217, 218, 219, 243, 245]
# [i] s3: [1, 28, 79, 123, 141, 159, 176, 187, 189, 191, 217, 219, 220, 221, 223, 237]
# [i] s4: [0, 26, 40, 53, 56, 64, 78, 82, 83, 85, 91, 113, 156, 169, 170, 173]
# [i] s5: [0, 1, 65, 71, 96, 130, 142, 169, 175, 189, 203, 212, 222, 237, 253, 255]
# [i] s6: [27, 49, 61, 78, 100, 101, 157, 178, 193, 200, 207, 221, 224, 237, 238, 246]
# [i] s7: [5, 10, 77, 79, 84, 96, 134, 154, 158, 169, 187, 191, 202, 221, 223, 232]
# [i] s8: [7, 72, 77, 84, 120, 131, 133, 151, 170, 176, 216, 240, 243, 251, 252, 253]

