#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>
#include <openssl/sha.h>


int char2int(unsigned char c) {
    if(c >= '0' && c <= '9')
        return c - '0';
    if(c >= 'a' && c <= 'f')
        return c - 'a' + 10;
    return -1;
}

unsigned char* hex2bin(const char* src) {
    if (strlen(src) % 2 != 0)
        return 0;
    unsigned char *dst = (unsigned char *) malloc(strlen(src) / 2);
    unsigned int i = 0;
    while(src[0] && src[1]) {
        dst[i++] = char2int(src[0]) * 16 + char2int(src[1]);
        src += 2;
    }
    return dst;
}

int main(int argc, char **argv) {

    unsigned char *hash_key = hex2bin("00c8bb35d44dcbb2712a11799d8e1316045d64404f337f4ff653c27607f436ea");

    unsigned char s1[] = { 25, 57, 64, 71, 98, 114, 129, 137, 143, 144, 175, 191, 194, 199, 215, 223 };
    unsigned char s2[] = { 8, 16, 32, 41, 50, 82, 144, 164, 180, 181, 209, 217, 218, 219, 243, 245 };
    unsigned char s3[] = { 1, 28, 79, 123, 141, 159, 176, 187, 189, 191, 217, 219, 220, 221, 223, 237 };
    unsigned char s4[] = { 0, 26, 40, 53, 56, 64, 78, 82, 83, 85, 91, 113, 156, 169, 170, 173 };
    unsigned char s5[] = { 0, 1, 65, 71, 96, 130, 142, 169, 175, 189, 203, 212, 222, 237, 253, 255 };
    unsigned char s6[] = { 27, 49, 61, 78, 100, 101, 157, 178, 193, 200, 207, 221, 224, 237, 238, 246 };
    unsigned char s7[] = { 5, 10, 77, 79, 84, 96, 134, 154, 158, 169, 187, 191, 202, 221, 223, 232 };
    unsigned char s8[] = { 7, 72, 77, 84, 120, 131, 133, 151, 170, 176, 216, 240, 243, 251, 252, 253 };

#pragma omp parallel for 
    for (int i1 = 0; i1 < sizeof(s1); i1++) {
        unsigned char msg[8] = { 0 };
        unsigned char hash_msg[32] = { 0 };
        msg[0] = s1[i1];
        for (int i2 = 0; i2 < sizeof(s2); i2++) {
            msg[1] = s2[i2];
            for (int i3 = 0; i3 < sizeof(s3); i3++) {
                msg[2] = s3[i3];
                for (int i4 = 0; i4 < sizeof(s4); i4++) {
                    msg[3] = s4[i4];
                    for (int i5 = 0; i5 < sizeof(s5); i5++) {
                        msg[4] = s5[i5];
                        for (int i6 = 0; i6 < sizeof(s6); i6++) {
                            msg[5] = s6[i6];
                            for (int i7 = 0; i7 < sizeof(s7); i7++) {
                                msg[6] = s7[i7];
                                for (int i8 = 0; i8 < sizeof(s8); i8++) {
                                    msg[7] = s8[i8];

                                    SHA256(msg, 8, hash_msg);
                                    if (memcmp(hash_key, hash_msg, 32) == 0) {
                                        printf("key = bytearray([%u, %u, %u, %u, %u, %u, %u, %u])\n", s1[i1], s2[i2], s3[i3], s4[i4], s5[i5], s6[i6], s7[i7], s8[i8]);
                                        exit(0);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return 1;
}

// $ gcc -o 2 2.c -fopenmp -lssl -lcrypto
// $ ./2
// key = bytearray([143, 164, 223, 169, 212, 237, 187, 240])

