#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>

#define DELTA 0x3c5428

#define TRACE 1
#define trace_print(fmt, ...) do { if (TRACE) printf(fmt, ##__VA_ARGS__); } while (0)

static unsigned int cst1[] = {0x93CC7820, 0x3850C1b4, 0x9C43DCD5, 0x24F82506};
static unsigned int cst2[] = {0x00070E15, 0x1C232A31, 0x383F464D, 0x545b6269};
static unsigned int key[]  = {0x612E7270, 0x6766722E, 0x666E632E, 0x2E76662E, 0x76706E73, 0x66407279, 0x70766766, 0x7465622E};

static unsigned int prev_mix_n_roll[16] = {0};
static unsigned int mix_n_roll[16] = {0};
static unsigned int sreg[4] = {0};
static unsigned int user[8] = {0};

char *data = NULL;
unsigned int data_size = 0;

void* prep_read(void *p) {
    return (void *)(&data[(long)p - DELTA]);
}__attribute__((used))

unsigned int kiwi(unsigned int in) {
	unsigned int tmp[8] = {0};
    unsigned int out;
	asm __volatile__ (
			"mov 		x21,%[in];"
			"and        x19,x21,#0xfffffff0;"
			"and        w21,w21,#0xf;"
			"add        x0,x19,#0x413, LSL #12;"
			"ld1        {v0.4s},%[cst1];"
			"rev32      v0.16b,v0.16b;"
			"ld1        {v1.4s},%[cst2];"
            "mov        v2.s[0x0],w19;"
            "mov        v2.s[0x1],w19;"
            "mov        v2.s[0x2],w19;"
            "mov        v2.s[0x3],w19;"
            "eor        v1.16b,v1.16b,v2.16b;"
            "sm4ekey    v0.4s,v0.4s,v1.4s;"
            "mov        v1.s[0x0],v0.s[0x3];"
            "mov        v1.s[0x1],v0.s[0x2];"
            "mov        v1.s[0x2],v0.s[0x1];"
            "mov        v1.s[0x3],v0.s[0x0];"
			"bl	    	prep_read;"
            "ld1        {v0.4s},[x0];"
            "rev32      v0.16b,v0.16b;"
            "sm4e       v0.4s,v1.4s;"
            "rev32      v0.16b,v0.16b;"
            "mov        v1.s[0x0],v0.s[0x3];"
            "mov        v1.s[0x1],v0.s[0x2];"
            "mov        v1.s[0x2],v0.s[0x1];"
            "mov        v1.s[0x3],v0.s[0x0];"

            "mov        x20,%[tmp];"
            "st1        {v1.4s},[x20];"

			"cmp        w21,#0xc;"
			"b.ls       LAB_00000fb0;"

			"add        x0,x19,#0x413, LSL #12;"
			"add        w1,w19,#0x10;"
			"add        x0,x0,#0x10;"
			"add        x3,x20,#0x10;"
			"ld1        {v0.4s},%[cst1];"
			"rev32      v0.16b,v0.16b;"
			"ld1        {v1.4s},%[cst2];"
			"mov        v2.s[0x0],w1;"
			"mov        v2.s[0x1],w1;"
			"mov        v2.s[0x2],w1;"
			"mov        v2.s[0x3],w1;"
			"eor        v1.16b,v1.16b,v2.16b;"
			"sm4ekey    v0.4s,v0.4s,v1.4s;"
			"mov        v1.s[0x0],v0.s[0x3];"
			"mov        v1.s[0x1],v0.s[0x2];"
			"mov        v1.s[0x2],v0.s[0x1];"
			"mov        v1.s[0x3],v0.s[0x0];"
			"bl	    	prep_read;"
			"ld1        {v0.4s},[x0];"
			"rev32      v0.16b,v0.16b;"
			"sm4e       v0.4s,v1.4s;"
			"rev32      v0.16b,v0.16b;"
			"mov        v1.s[0x0],v0.s[0x3];"
			"mov        v1.s[0x1],v0.s[0x2];"
			"mov        v1.s[0x2],v0.s[0x1];"
			"mov        v1.s[0x3],v0.s[0x0];"
            "st1        {v1.4s},[x3];"

        "LAB_00000fb0:"
            "and        x1,x21,#0xff;"
            "ldr        %w[out],[x20, x1, LSL #0x0];"

			:[out] "=r"(out)
			:[in] "wr"(in), [cst1] "m"(cst1), [cst2] "m"(cst2), [tmp] "rm"(tmp) 
            : "x1", "x2", "x3", "x19", "x20", "x21", "v0", "v1", "v2", "x29", "x30", "memory"
	);
    return out;
}

int setup_data(void) 
{
    int fd;
    char *path = "/root/safe_02/decrypted_file";
    fd = open(path, O_RDONLY);
    if (fd <= 0){
        fprintf(stderr, "can't open %s for reading\n", path);
        exit(-1);
    }
    struct stat st;
    if (fstat(fd, &st) < 0) {
        fprintf(stderr, "fstat error\n");
        exit(-1);
    }
    data_size = st.st_size;
    data = (char *)mmap(0, st.st_size, PROT_READ, MAP_SHARED | MAP_POPULATE, fd, 0);
    if (data <= 0) {
        fprintf(stderr, "failed to mmap\n");
        exit(-1);
    }
    return 0;
}

void print_mix_n_roll() 
{
    int i;
    printf("\n- Mix'n'Roll -\n");
    for (i = 0; i < 16; i++) {
        if (prev_mix_n_roll[i] == mix_n_roll[i])
            printf(" [0x%x] : 0x%x\n", i, mix_n_roll[i]);
        else {
            printf("\033[01;31m [0x%x] : 0x%x.\e[0m\n", i, mix_n_roll[i]);
            prev_mix_n_roll[i] = mix_n_roll[i];
        }
    }
    printf("\n");
}

unsigned int smc(unsigned int code, unsigned int arg1, unsigned int arg2) 
{
    if (code == 0x83010001) {
        return mix_n_roll[arg1];
    }
    else if (code == 0x83010002) {
        mix_n_roll[arg1] = arg2;
    }
    else if (code == 0x83010003) {
        sreg[arg1] = arg2;
    }
    else if (code == 0x83010010) {
        trace_print("    DUP  [0x%x] = 0x%x      // [0x%x]\n", arg1, mix_n_roll[arg2], arg2);
        mix_n_roll[arg1] = mix_n_roll[arg2];
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010011) {
        trace_print("    DEC  [0x%x] -= 1        // (0x%x - 1)\n", arg1, mix_n_roll[arg1]);
        mix_n_roll[arg1] -= 1;
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010012) {
        trace_print("    ADD  [0x%x] += [0x%x]   // (0x%x + 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], mix_n_roll[arg2], mix_n_roll[arg1] + mix_n_roll[arg2]);
        mix_n_roll[arg1] += mix_n_roll[arg2];
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010013) {
        trace_print("    SUB  [0x%x] -= [0x%x]   // (0x%x - 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg2], mix_n_roll[arg1], mix_n_roll[arg2] - mix_n_roll[arg1]);
        mix_n_roll[arg1] = mix_n_roll[arg2] - mix_n_roll[arg1];
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010016) {
        trace_print("    XOR  [0x%x] ^= [0x%x]   // (0x%x ^ 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], mix_n_roll[arg2], mix_n_roll[arg1] ^ mix_n_roll[arg2]);
        mix_n_roll[arg1] = mix_n_roll[arg2] ^ mix_n_roll[arg1];
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x8301001b) {
        fprintf(stderr, "Not supported");
        exit(-1);
    }
    else if (code == 0x83010020) {
        fprintf(stderr, "Not supported");
        exit(-1);
    }
    else if (code == 0x83010022) {
        trace_print("    ADD  [0x%x] += 0x%x     // (0x%x + 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], arg2, mix_n_roll[arg1] + arg2);
        mix_n_roll[arg1] = mix_n_roll[arg1] + arg2;
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010023) {
        trace_print("    SUB  [0x%x] -= 0x%x     // (0x%x - 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], arg2, mix_n_roll[arg1] - arg2);
        mix_n_roll[arg1] = mix_n_roll[arg1] - arg2;
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010024) {
        trace_print("    SHL  [0x%x] << 0x%x     // (0x%x << 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], arg2, mix_n_roll[arg1] << arg2);
        mix_n_roll[arg1] = mix_n_roll[arg1] << arg2;
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010025) {
        trace_print("    SHR  [0x%x] >> 0x%x     // (0x%x >> 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], arg2, mix_n_roll[arg1] >> arg2);
        mix_n_roll[arg1] = mix_n_roll[arg1] >> arg2;
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010026) {
        trace_print("    XOR  [0x%x] ^ 0x%x      // (0x%x ^ 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], arg2, mix_n_roll[arg1] ^ arg2);
        mix_n_roll[arg1] = mix_n_roll[arg1] ^ arg2;
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010027) {
        trace_print("    AND  [0x%x] & 0x%x      // (0x%x & 0x%x = 0x%x)\n", arg1, arg2, mix_n_roll[arg1], arg2, mix_n_roll[arg1] & arg2);
        mix_n_roll[arg1] = mix_n_roll[arg1] & arg2;
        mix_n_roll[0xf] += 3;
    }
    else if (code == 0x83010028) {
        trace_print("    JMP  0x%x -> 0x%x\n", mix_n_roll[0xf], arg2);
        mix_n_roll[0xf] = arg2;
    }
    else if (code == 0x83010029) {
        fprintf(stderr, "Not supported");
        exit(-1);
    }
    else {
        fprintf(stderr, "Not supported");
        exit(-1);
    }
    return 0;
}

void cursor_plus_3() {
    unsigned cur = smc(0x83010001, 0xf, 0);
    smc(0x83010002, 0xf, cur + 3);
}

void write(unsigned int dest, unsigned int val) 
{
    if (dest >= 0x100000 && dest <= 0x10001e) {
        unsigned char* p = (unsigned char *)&key;
        *(unsigned int *) &p[dest - 0x100000] = val;
        trace_print("     *** KEY WRITE: 0x%x (0x%x)\n", val, dest);
    } else if (dest >= 0x100020 && dest <= 0x10003e) {
        unsigned char* p = (unsigned char *)&user;
        *(unsigned int *) &p[dest - 0x100020] = val;
        trace_print("     *** USER UPDATED: 0x%x (0x%x)\n", val, dest);
    } else {
        fprintf(stderr, "FAIL WRITE: 0x%x (0x%x)", val, dest);
        exit(-1);
    }
}

unsigned int load(unsigned int src) 
{
    unsigned int val;
    if (src >= 0x100020 && src <= 0x10003e) {
        unsigned char* p = (unsigned char *)&user;
        val = *(unsigned int *) &p[src - 0x100020];
        trace_print("     *** USER LOADED 0x%x (0x%x)\n", val, src);
    } else if (src >= 0x100000 && src <= 0x10001e) {
        unsigned char* p = (unsigned char *)&key;
        val = *(unsigned int *) &p[src - 0x100000];
        if (val == 0) {
            fprintf(stderr, "FAIL (KEY NOT LOADED: 0x%x)", src);
            exit(-1);
        }
        trace_print("     *** KEY LOADED 0x%x (0x%x)\n", val, src);
    } else if (src < 0x100fff) {
        val = kiwi(src);
    } else {
        fprintf(stderr, "FAIL (LOAD: 0x%x)", src);
        exit(-1);
    }
    return val;
}

unsigned int sub_E2005A4(unsigned int code, unsigned int *finish) 
{
    *finish = 0;

    if (((code >> 0x14) & 0xff) == 12)
    {
        unsigned int addr, val;
        unsigned int key_sel = (smc(0x83010001, 12, 0) >> 2) & 0x7;
        switch (key_sel) {
            case 0:
                addr = 0x100004;
                val  = 0x6766722E; //"gfr."
                break;
            case 1:
                addr = 0x100008;
                val  = 0x666E632E; //"fnc.";
                break;
            case 2:
                addr = 0x10000C;
                val  = 0x2E76662E; //".vf.";
                break;
            case 3:
                addr = 0x100010;
                val  = 0x76706E73; //"vpns";
                break;
            case 4:
                addr = 0x100014;
                val  = 0x66407279; //"f@ry";
                break;
            case 5:
                addr = 0x100018;
                val  = 0x70766766; //"pvgf";
                break;
            case 6:
                addr = 0x10001C;
                val  = 0x7465622E; //"teb.";
                break;
            default:
                addr  = 0x100000;
                val = 0x612E7270; //"a.rp";
                break;
        }
        write(addr, val);
        cursor_plus_3();
        return 0;
    }
    if (((code >> 0x14) & 0xff) == 0xA) {
        *finish = smc(0x83010001, 0, 0);
        cursor_plus_3();
        return 1;
    }

    if (((code & 0xff) == 13) || ((code & 0xff) == 14))
        cursor_plus_3();

    if (((code >> 0x12) & 3) == 0) {
        switch ((code >> 0x14) & 0xf) {
            case 0:
                //res = smc(0x83010001, (code >> 0xa) & 0xf, 0);
                //smc(0x83010002, (code >> 0xe) & 0xf, res);
                //cursor_plus_3();
                smc(0x83010010, (code >> 0xe) & 0xf, (code >> 0xa) & 0xf);
                return 0; 
            case 1:
                smc(0x83010011, (code >> 0xe) & 0xf, (code >> 0xa) & 0xf);
                return 0;
            case 2:
                smc(0x83010012, (code >> 0xe) & 0xf, (code >> 0xa) & 0xf);
                return 0;
            case 3:
                smc(0x83010013, (code >> 0xe) & 0xf, (code >> 0xa) & 0xf);
                return 0;
            case 6:
                smc(0x83010016, (code >> 0xe) & 0xf, (code >> 0xa) & 0xf);
                return 0;
            case 0xB:;
                     unsigned int res = smc(0x83010001, (code >> 0xe) & 0xf, 0);
                     unsigned int val = (res & 0xff) << 0x8 | ((res >> 0x8) & 0xff);
                     smc(0x83010002, (code >> 0xe) & 0xf, val);
                     trace_print("    REV  [0x%x] = 0x%x (before 0x%x)\n", (code >> 0xe) & 0xf, val, res);
                     cursor_plus_3();
                     return 0;
            default:
                     return -1;
        }
        return -1;
    }
    if (((code >> 0x12) & 3) == 3) {
        switch ((code >> 0x14) & 0xf) {
            case 0:
                trace_print("    NEW  [0x%x] = 0x%x\n", (code >> 0xe) & 0xf, code & 0x3fff);
                smc(0x83010002, (code >> 0xe) & 0xf, code & 0x3fff);
                cursor_plus_3();
                return 0;
            case 2:
                smc(0x83010022, (code >> 0xe) & 0xf, code & 0x3fff);
                return 0;
            case 3:
                smc(0x83010023, (code >> 0xe) & 0xf, code & 0x3fff);
                return 0;
            case 4:
                //res = smc(0x83010001, (code >> 0xe) & 0xf, 0);
                //smc(0x83010002, (code >> 0xe) & 0xf, res << (code & 0x3fff));
                //cursor_plus_3();
                smc(0x83010024, (code >> 0xe) & 0xf, code & 0x3fff);
                return 0;
            case 5:
                //res = smc(0x83010001, (code >> 0xe) & 0xf, 0);
                //smc(0x83010002, (code >> 0xe) & 0xf, res >> (code & 0x3fff));
                //cursor_plus_3();
                smc(0x83010025, (code >> 0xe) & 0xf, code & 0x3fff);
                return 0;
            case 6:
                smc(0x83010026, (code >> 0xe) & 0xf, code & 0x3fff);
                return 0;
            case 7:
                smc(0x83010027, (code >> 0xe) & 0xf, code & 0x3fff);
                return 0;
            case 8:
                smc(0x83010028, (code >> 0xe) & 0xf, code & 0x3fff);
                return 0;
            case 9:;
                   unsigned int res = smc(0x83010001, (code >> 0xe) & 0xf, 0);
                   // printf("    if [0x%x] != 0 (0x%x)\n", (code >> 0xe) & 0xf, res);
                   if (res == 0) {
                       cursor_plus_3();
                   } else {
                       trace_print("    JUMP TO 0x%x\n", (code & 0x3fff));
                       smc(0x83010002, 0xf, code & 0x3fff);
                   }
                   return 0;
            default:
                   cursor_plus_3();
                   return 0;
        }
        return -1;
    }
    if (((code >> 0x12) & 3) != 1) {
        if (((code >> 0x14) & 0xff) == 0) {
            unsigned addr = smc(0x83010001, (code >> 0xe) & 0xf, 0);
            unsigned val = smc(0x83010001, (code >> 0xa) & 3, 0);
            write(addr, val);
            cursor_plus_3();
            return 0;
        }
        else 
            return -1;
    } else {
        unsigned int addr = smc(0x83010001, (code >> 0xa) & 0xf, 0);
        unsigned int val = load(addr);
        smc(0x83010002, (code >> 0xe) & 0xf, val);
        trace_print("    NEW  [0x%x] = 0x%x\n", (code >> 0xe) & 0xf, val);
        cursor_plus_3();
        return 0;
    }
    return -1;
}

void init_sreg(unsigned int arg1, unsigned int arg2, unsigned int arg3, unsigned int arg4, unsigned int arg5, unsigned int arg6, unsigned int arg7, unsigned int arg8)
{
    user[0] = arg1;
    user[1] = arg2;
    user[2] = arg3;
    user[3] = arg4;
    user[4] = arg5;
    user[5] = arg6;
    user[6] = arg7;
    user[7] = arg8;

    smc(0x83010003, 0, arg1);
    smc(0x83010003, 1, arg2);
    smc(0x83010003, 2, arg3);
    smc(0x83010003, 3, arg4);
}

int f(unsigned int nb_step) 
{
    unsigned int i, code;
    unsigned int finish, res;
    for (i = 0; i < nb_step; i++) {
        code = load(mix_n_roll[0xf]) & 0xffffff;
        
        if (TRACE)
            print_mix_n_roll();

        res = sub_E2005A4(code, &finish);
        if (res == -1) {
            printf("Error: 0x%x\n", code);
            return -1;
        }
        if (finish != 0) {
            printf("Finish!\n");
            return 0;
        }
    }
    return -1;
}

int main(int argc, char * argv[]) 
{
    unsigned int arg1 = 0x4a3a2a1a;
    unsigned int arg2 = 0x8a7a6a5a;
    unsigned int arg3 = 0x4b3b2b1b;
    unsigned int arg4 = 0x8b7b6b5b;
    unsigned int arg5 = 0x4c3c2c1c;
    unsigned int arg6 = 0x8c7c6c5c;
    unsigned int arg7 = 0x4d3d2d1d;
    unsigned int arg8 = 0x8d7d6d5d;

    setup_data();
    init_sreg(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);

    f(100000);

    munmap(data, data_size);
    return 0;
}

// $ aarch64-linux-gnu-gcc -o 1 1.c -mcpu=cortex-a75 -march=armv8.2-a+sm4
// $ scp -P 5555 1 root@localhost:/root/
//
// # /root/1

